{% extends "ajax/game/game.html.twig" %}
{% block menu_text %}
    {{parent()}}
    <li class="back-dash" x-ajax-href="{{ url('game_landing') }}">{{ 'Zum Spiel'|trans({},'global') }}</li>
{% endblock %}

{# @var forum \App\Entity\Forum #}
{# @var permission \App\Structures\ForumPermissionAccessor #}

{% macro display_thread_list( list, fid, icon, title, select, jump, permission ) %}
    <div class="forum-note">
        <b><i class="fa {{ icon }}"></i> {{ title }}</b>
        {% for thread in list %}
            {% set postUrl = path('forum_viewer_controller', {fid: fid, tid: thread.id }) %}
            {% if thread.id == select and jump > 0 %}
                {% set postUrlFg = path('forum_viewer_controller', {fid: fid, tid: thread.id, pid: jump }) %}
            {% else %}
                {% set postUrlFg = postUrl %}
            {% endif %}
            <div class="row forum-thread {% if not thread.new %}forum-thread-unread{% endif%}" x-public-route="{{ path('forum_thread_view', {fid: fid, tid: thread.id }) }}" {% if postUrl != postUrlFg %}x-post-source-next="{{ postUrlFg }}"{% endif%} x-post-source="{{ postUrl }}" x-thread-id="{{ thread.id }}">
                {# @var thread \App\Entity\Thread #}
                <div class="cell rw-1 status" style="padding: 5px;">
                    {% if thread.locked %}
                        <img alt="" src="{{ asset('build/images/icons/lock.gif') }}" />
                    {% else %}
                        &nbsp;
                    {% endif %}
                </div>
                <div class="cell rw-8 title"  style="padding: 5px;">
                    <div>
                        {% if thread.translatable %}
                            {{ thread.title|trans({},'game') }}
                        {% else %}
                            {{ thread.title }}
                        {% endif %}
                        {% if permission.moderate and thread.reportedPosts %}
                            <span class="float-right">
                                <img alt="" src="{{ asset('build/images/forum/warning.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Mindestens ein Post in diesem Thema wurde den Moderatoren gemeldet.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% endif %}
                        {% if thread.hasAdminAnnounce %}
                            <span class="float-right">
                                <img alt="" src="{{ asset('build/images/forum/adminAnnounce.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Dieses Thema enthält offizielle Ansagen der Website Administratoren.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% elseif thread.hasOracleAnnounce %}
                            <span class="float-right">
                                <img src="{{ asset('build/images/forum/announce.png') }}" />
                                <div class="tooltip forum-tooltip">
                                    {{'Dieses Thema enthält Ansagen von Community-Vertretern.'|trans({}, 'global')}}
                                </div>
                            </span>
                        {% endif %}
                    </div>
                </div>
                <div class="cell rw-3 right count" style="background:#593223; padding: 5px;">
                    {% if thread.visiblePosts|length > 1 %}
                        {{ thread.visiblePosts|length - 1 }}
                    {% endif %}
                    <br />
                    {% set last_post = thread.lastPost %}
                    {% if last_post and last_post.owner %}
                        {% if last_post.owner.name == 'Der Rabe' %}
                            {{ 'Der Rabe'|trans({},'global') }}
                        {% else %}
                            {{ last_post.owner.name }}
                        {% endif %}
                    {% elseif thread.owner %}
                        {% if thread.owner.name == 'Der Rabe' %}
                            {{ 'Der Rabe'|trans({},'global') }}
                        {% else %}
                            {{ thread.owner.name }}
                        {% endif %}
                    {% else %}
                        {{ 'Der Rabe'|trans({},'global') }}
                    {% endif %}
                </div>
            </div>
        {% endfor %}
    </div>
{% endmacro %}

{% block ajax %}
    <div class="row">
        <div class="cell rw-12">
            <div class="row">
                <div class="cell padded rw-5 rw-md-12">
                    <div class="forum-control">
                        <b><i class="fa fa-scroll"></i> {{ forum.title }}</b>
                        <div class="forum-button-bar">
                            <div x-ajax-href="{{ url('forum_list') }}" class="forum-button"><img src="{{ asset('build/images/forum/back.png') }}" /><div class="tooltip forum-tooltip">{{ 'Zurück'|trans({},'global') }}</div></div>
                            <div x-ajax-href="{{ url('forum_view', {id: forum.id}) }}" class="forum-button"><img src="{{ asset('build/images/forum/refresh.png') }}" /><div class="tooltip forum-tooltip">{{ 'Liste der Themen aktualisieren'|trans({},'global') }}</div></div>
                            {% if is_granted("ROLE_FORUM_BANNED") or not permission.create_thread() %}
                                <div class="forum-button-disabled" id="banned">{{ 'Neues Thema'|trans({},'global') }}</div>
                            {% else %}
                                <div x-forum-action="new" class="forum-button" id="new-thread-button"><span>{{ 'Neues Thema'|trans({},'global') }}</span></div>
                            {% endif %}    
                        </div>
                    </div>
                    <br />
                    {% if forum.description is not empty %}
                        <div class="forum-control">
                            <div class="quote">
                                <i class="fa fa-quote-left"></i><span>{{ forum.description }}</span><i class="fa fa-quote-right"></i>
                            </div>
                        </div>
                        <br />
                    {% endif %}

                    {% if permission.only_mod_access %}
                        <div class="forum-control">
                            <b><i class="fa fa-exclamation"></i> {{ 'Moderation'|trans({},'global') }}</b>
                            <div class="pad">{{ 'Du moderierst dieses Forum, verfügst aber nicht über Leserechte. Es werden dir nur Threads angezeigt, in denen mindestens ein Post gemeldet wurde.' }}</div>
                        </div>
                        <br />
                    {% endif %}

                    {% if pinned_threads %}
                        {{ _self.display_thread_list(pinned_threads, forum.id, 'fa-thumbtack', 'Sticky'|trans({}, 'global'), select, jump, permission) }}
                        <br />
                    {% endif %}

                    {{ _self.display_thread_list(threads, forum.id, 'fa-scroll', forum.title, select, jump, permission) }}
                    {% if pages > 1 %}
                        <div class="row">
                            <div class="cell rw-12 padded center">
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="1"><i class="fa fa-fast-backward"></i></div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ current_page - 1 }}"><i class="fa fa-backward"></i></div>
                                <div class="forum-button">{{ 'Seite %page%/%pages%'|trans({'%page%': current_page, '%pages%': pages},'global') }}</div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ current_page + 1 }}"><i class="fa fa-forward"></i></div>
                                <div class="forum-button" x-forum-action="thread-pager" x-to-page="{{ pages }}"><i class="fa fa-fast-forward"></i></div>
                            </div>
                        </div>
                    {% endif %}
                </div>

                <div class="cell padded rw-7 rw-md-12">
                    <div id="forum-content">
                        <div class="forum-note">
                            <b>{{ 'Bitte halte dich an die Regeln:'|trans({},'global') }}</b>
                            <ul>
                                <li>{{ 'Achte auf deine Rechtschreibung'|trans({},'global') }}</li>
                                <li>{{ 'Bleibe höflich und freundlich'|trans({},'global') }}</li>
                                <li>{{ 'Werbung ist verboten (Links etc.)'|trans({},'global') }}</li>
                            </ul>
                        </div>
                    </div>
                    <div id="forum-editor"></div>
                    <div id="forum-editor-anchor"></div>

                </div>
            </div>

        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>

        function get_forum_editor() {
            let editor = document.getElementById('forum-editor');
            if (!editor) {
                editor = document.createElement('div');
                editor.setAttribute('id', 'forum-editor');
                let anchor = document.getElementById('forum-editor-anchor');
                anchor.parentNode.insertBefore(editor, anchor);
            }
            return editor;
        }

        {% if not is_granted("ROLE_FORUM_BANNED") and permission.create_thread() %}
            let new_post_btns = document.querySelectorAll('[x-forum-action=new]');
            for (let i = 0; i < new_post_btns.length; i++)
                new_post_btns[i].addEventListener('click', function() {
                    for (let j = 0; j < thread_buttons.length; j++) thread_buttons[j].classList.remove('selected');
                    let viewer = document.getElementById('forum-content');
                    {let c; while ((c = viewer.firstChild)) viewer.removeChild(c);}
                    $.ajax.no_history().load( get_forum_editor(), '{{ url('forum_thread_editor_controller', {id: forum.id}) }}', false )
                })            
        {% endif %}

        let thread_buttons = document.querySelectorAll('[x-thread-id]');
        for (let i = 0; i < thread_buttons.length; i++) {
            thread_buttons[i].addEventListener('click', function () {
                for (let j = 0; j < thread_buttons.length; j++) thread_buttons[j].classList.remove('selected');
                this.classList.add('selected');
                let editor = get_forum_editor();
                {
                    let c;
                    while ((c = editor.firstChild)) editor.removeChild(c);
                }

                let load_url = this.getAttribute('x-post-source');
                if (this.getAttribute('x-post-source-next')) {
                    load_url = this.getAttribute('x-post-source-next');
                    this.setAttribute('x-post-source-next','');
                }

                $.ajax.no_history().load(document.getElementById('forum-content'), load_url, false, {}, get_forum_editor)
                $.ajax.push_history(this.getAttribute('x-public-route'));
            });
            thread_buttons[i].addEventListener('mousedown', function (e) {
                if (e.button === 1) {
                    e.preventDefault();
                    window.open(this.getAttribute('x-public-route'), '_blank');
                }
            });
        }

        let selection_target = document.querySelector('[x-thread-id="{{ select }}"]');
        if (selection_target) selection_target.click();

        let nav_buttons =  document.querySelectorAll('[x-forum-action="thread-pager"][x-to-page]');
        for (let i = 0; i < nav_buttons.length; i++)
            nav_buttons[i].addEventListener('click', function() {
                $.ajax.no_history().load( null, '{{ path('forum_view', {id: forum.id}) }}', false, {page: parseInt( this.getAttribute('x-to-page') )} )
            })

    </script>
{% endblock %}